
/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Create a random string of the alphabet and digits of the length specified
 * by the caller.
 * Note that the -rand parameter is very important with this function when
 * used on the web.  Else a new number will not be created until all the agents
 * have processed this function.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/opensrc/dbemail/src/RCS/RandomString.p,v 1.1 2001/12/17 20:25:46 sauge Exp $" NO-UNDO.

DEF INPUT PARAMETER pLength   AS INTEGER NO-UNDO.
DEF OUTPUT PARAMETER pString  AS CHARACTER NO-UNDO.

DEF VAR lAlphabet AS CHARACTER NO-UNDO.
DEF VAR i         AS INTEGER NO-UNDO.

{Log.i}

{LogIt.i '"Begin Program"'}

ASSIGN 
lAlphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
i = 0
pString = "".

DO WHILE i < pLength:

  ASSIGN 
  i = i + 1
  pString = pString + SUBSTRING(lAlphabet, RANDOM(1,LENGTH(lAlphabet)), 1).

END.

