/* file: memptr.i
 * Scott Auge
 * Questions and Documentation require Support Contract
 * sauge@aezinc.com
 *
 * This file released into the public domain.
 *
 * Allow string operations on memory pointer based data
 * used for .so and socket operations.
 *
 */

DEF VAR RCSVersionMemptri AS CHARACTER INIT "$Header: /home/appl/opensrc/dbemail/src/RCS/memptr.i,v 1.1 2001/12/17 20:25:59 sauge Exp $" NO-UNDO. 

PROCEDURE lmemset:

  DEF INPUT PARAMETER m AS MEMPTR NO-UNDO.
  DEF INPUT PARAMETER c AS CHARACTER NO-UNDO.
  
  DEF VAR i AS INTEGER INIT 1 NO-UNDO.
  
  DO while i < GET-SIZE(m):
    PUT-BYTE (mData, i) = ASC (c).
    ASSIGN i = i + 1.
  END.
  
END.

PROCEDURE lmemput:

  DEF INPUT PARAMETER m AS MEMPTR NO-UNDO.
  DEF INPUT PARAMETER s AS CHARACTER NO-UNDO.

  DEF VAR i AS INTEGER INIT 1 NO-UNDO.

  DO WHILE i < GET-SIZE(m):
    IF i < LENGTH (s) + 1 THEN
      PUT-BYTE (mData, i) = ASC(SUBSTRING (s, i, 1)).
    ELSE
      PUT-BYTE (mData, i) = 0.
    ASSIGN i = i + 1.
  END.

END.

PROCEDURE lmemget:

  DEF INPUT PARAMETER  m AS memptr NO-UNDO.
  DEF OUTPUT PARAMETER c AS CHARACTER NO-UNDO.
  
  c = GET-BYTES (mData, 1, GET-SIZE(mData)).

END.
