
/* Auge Emmons & Ziola, Inc.
 * Questions and Documentation require Support Contract
 * http://www.aezinc.com
 *
 * This file is released into the public domain.  
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/appl/opensrc/dbemail/src/RCS/sockemail.p,v 1.1 2001/12/17 20:25:46 sauge Exp $" NO-UNDO.

/****************************************************************/
/*   sockemail.p                                                */
/*   Modifications:                                             */
/*   Who       |  Date |Description                             */
/* =============================================================*/
/* S. Auge   |08/08/00 | Made the code use socket connection to */
/*                       mail server instead of using sendmail  */
/*                       command line.  Derived from email.p    */
/* S. Auge   |08/09/00 | Use Parm records for defaults.         */
/* S. Ziola  |10/06/00 | Add ASCII file attachment              */
/* S. Ziola  |10/06/00 | Add BINARY file attachment             */
/* S. Auge   |02/04/01 | Add Speedy Mercer's Patch              */
/****************************************************************/


&GLOBAL-DEFINE LOGGER PUT STREAM sLogFile UNFORMATTED TODAY " " STRING (TIME, "hh:mm:ss") " "

DEF INPUT PARAMETER cEmailFrom        AS CHAR NO-UNDO.
DEF INPUT PARAMETER cEmailTo          AS CHAR NO-UNDO.
DEF INPUT PARAMETER cEmailCC          AS CHAR NO-UNDO.
DEF INPUT PARAMETER cEmailDelimiter   AS CHAR NO-UNDO.
DEF INPUT PARAMETER cFileAttachment   AS CHAR NO-UNDO.
DEF INPUT PARAMETER cFileName         AS CHAR NO-UNDO.
DEF INPUT PARAMETER cSubject          AS CHAR NO-UNDO.
DEF INPUT PARAMETER cMessageData      AS CHAR NO-UNDO.
DEF INPUT PARAMETER cMimeHeader       AS CHAR NO-UNDO.

DEF VAR LSystemName                   AS CHAR NO-UNDO FORMAT "X(50)".
DEF VAR LTempFile                     AS CHAR NO-UNDO INIT "/tmp/".
DEF VAR i_EmailCCCounter              AS INT  NO-UNDO.
DEF VAR cDelimiter                    AS CHAR NO-UNDO.
DEF VAR iCounter                      AS INT  NO-UNDO.
DEF VAR iLineCount                    AS INT  NO-UNDO.
DEF VAR iMaxSize                      AS INT  NO-UNDO.
DEF VAR cTempValue                    AS CHAR NO-UNDO.
DEF VAR cBoundary                     AS CHAR NO-UNDO.
DEF VAR cMimeType                     AS CHAR NO-UNDO.
DEF VAR cCharSet                      AS CHAR NO-UNDO.
DEF VAR cFileType                     AS CHAR NO-UNDO.
DEF VAR cFile                         AS CHAR NO-UNDO.
DEF VAR cImportData                   AS CHAR NO-UNDO.
DEF VAR mData                         AS MEMPTR NO-UNDO.
DEF VAR hSocket                       AS HANDLE NO-UNDO.
DEF VAR lOK                           AS LOGICAL NO-UNDO.
DEF VAR lRC                           AS LOGICAL NO-UNDO.
DEF VAR lConnectParameters            AS CHARACTER NO-UNDO.
DEF VAR lSMTPCommand                  AS CHARACTER FORMAT "x(90)" NO-UNDO.
DEF VAR lServerResponse               AS CHARACTER FORMAT "x(40)" NO-UNDO.
DEF VAR iLogLevel                     AS INTEGER NO-UNDO.
DEF VAR cMonth                        AS CHAR NO-UNDO 
         INIT "Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec".
DEF VAR cWeekDay                      AS CHAR NO-UNDO 
         INIT "Sun,Mon,Tue,Wed,Thu,Fri,Sat".
DEF VAR cLocalFile                    AS CHAR NO-UNDO.
DEF VAR cBinaryFile                   AS CHAR NO-UNDO.
DEF VAR cEncodeDir                    AS CHAR NO-UNDO.
DEFINE STREAM sLogfile.

{memptr.i}
/****************************************************************/
/* Only Log attachments if debug level = 1                      */
/****************************************************************/
FIND Parms NO-LOCK
WHERE Parms.Application = "EMail"
  AND Parms.GroupName = "Common"
  AND Parms.ParmName = "LogLevel" NO-ERROR.
ASSIGN
  iLogLevel = IF AVAILABLE parms THEN INTEGER(parms.parmValue) ELSE 2.
/****************************************************************/
/* All emails generated by this program are recorded.           */
/****************************************************************/

FIND Parms NO-LOCK
WHERE Parms.Application = "EMail"
  AND Parms.GroupName = "Common"
  AND Parms.ParmName = "LogFile"
  NO-ERROR.

OUTPUT STREAM sLogFile TO VALUE(Parms.ParmValue) UNBUFFERED APPEND.
{&Logger} "Socket email started" SKIP.
{&Logger} "Input Parameters" SKIP.
{&Logger} "cEmailFrom = " cEmailFrom SKIP.
{&Logger} "cEmailTo = " cEmailTo SKIP.
{&Logger} "cEmailCC = " cEmailCC SKIP.
{&Logger} "cEmailDelimiter = " cEmailDelimiter SKIP.
{&Logger} "cFileAttachment = " cFileAttachment SKIP.
{&Logger} "cFileName = " cFileName SKIP.
{&Logger} "cSubject = " cSubject SKIP.
{&Logger} "cMessageData = " cMEssageData SKIP.
{&Logger}  "cMimeHeader = " cMimeHeader SKIP.
/****************************************************************/
/* Create the socket, log in the log file that it was succes-   */
/* ful or not.                                                  */
/****************************************************************/
FIND Parms NO-LOCK
WHERE Parms.Application = "EMail"
  AND Parms.GroupName = "Common"
  AND Parms.ParmName = "Encode Directory"
  NO-ERROR.
ASSIGN
  cEncodeDir = IF AVAILABLE parms THEN parms.parmvalue ELSE "/tmp/".
IF SUBSTRING(cEncodeDir,LENGTH(cEncodeDir),1) <> "/" THEN
  ASSIGN
    cEncodeDir = cEncodeDir + "/".

CREATE SOCKET hSocket.
hSocket:SET-SOCKET-OPTION ("TCP-NODELAY", "FALSE").
hSocket:SET-SOCKET-OPTION ("SO-LINGER", "FALSE").

SET-SIZE (mData) = 500.

/****************************************************************/
/* Made it along - lets connect to the mail server.             */
/****************************************************************/

FIND Parms NO-LOCK
WHERE Parms.Application = "EMail"
  AND Parms.GroupName = "Common"
  AND Parms.ParmName = "MailHub"
  NO-ERROR.

ASSIGN lConnectParameters = '-H ' + Parms.ParmValue + ' -S smtp'.

hSocket:CONNECT(lConnectParameters) NO-ERROR.

IF hSocket:CONNECTED() = FALSE THEN DO:
  {&LOGGER} 'Unable to Connect'.
  RETURN.
END.  /* Cannot make a connection to mail server */

{&LOGGER} "Socket Connection Established.~n" .

RUN ProcessServerResponse (OUTPUT lServerResponse).
{&LOGGER} lServerResponse "~n".

/****************************************************************/
/* Message bodies containing ~n do not work.  Change them to ~r */
/****************************************************************/

ASSIGN
  cDelimiter   = cEmailDelimiter
  /* cMessageData = REPLACE(cMessageData,"~n","~r")*/ .

/****************************************************************/
/* SMTP requires we know the name of the machine we are calling */
/* from.                                                        */
/****************************************************************/

FIND Parms NO-LOCK
WHERE Parms.Application = "EMail"
  AND Parms.GroupName = "Common"
  AND Parms.ParmName = "SenderMachine"
  NO-ERROR.

ASSIGN lSystemName = Parms.ParmValue.

{&LOGGER} "This system named " lSystemName "~n".

/****************************************************************/
/* Begin sending message                                        */
/****************************************************************/

ASSIGN lSMTPCommand = "HELO " + LSystemName + " ~n".
RUN ip-OutputData(lSMTPCommand,No).

ASSIGN lSMTPCommand = "MAIL From: " + cEmailFrom + "~n".
RUN ip-OutputData(lSMTPCommand,No).

/****************************************************************/
/* Loop through all To's                                        */
/****************************************************************/

IF cEmailTo <> "" THEN
DO iCounter = 1 TO NUM-ENTRIES(cEmailTo,cDelimiter):

  ASSIGN lSMTPCommand = "RCPT TO: "
                      + ENTRY(iCounter,cEmailTo,cDelimiter)
                      + "~n".
  RUN ip-OutputData(lSMTPCommand,No).

END.

/****************************************************************/
/* Loop through all CC's                                        */
/****************************************************************/

IF cEmailCC <> "" THEN
DO i_EMailCCCounter = 1 TO NUM-ENTRIES(cEmailCC,cEmailDelimiter):

  ASSIGN lSMTPCommand = "RCPT TO: "
                      + ENTRY(i_EMailCCCounter,cEmailCC,cEmailDelimiter)
                      + "~n".
  RUN ip-OutputData(lSMTPCommand,No).

END.

/****************************************************************/
/* Spill out mail header information.                           */
/****************************************************************/

ASSIGN lSMTPCommand = "DATA ~n".

RUN ip-OutputData(lSMTPCommand,No).

ASSIGN lSMTPCommand = "From: " + cEmailFrom + " ~n".

/****************************************************************/
/* Loop through all To's                                        */
/****************************************************************/

IF cEmailTo <> "" THEN
DO iCounter = 1 TO NUM-ENTRIES(cEmailTo,cDelimiter):
  ASSIGN lSMTPCommand = lSMTPCommand
                      + "To: "
                      + ENTRY(iCounter,cEmailTo,cDelimiter)
                      + " ~n".
END.

/****************************************************************/
/* Loop through all CC's                                        */
/****************************************************************/

IF cEmailCC <> "" THEN
DO i_EMailCCCounter = 1 TO NUM-ENTRIES(cEmailCC,cEmailDelimiter):
  ASSIGN lSMTPCommand = lSMTPCommand
                      + "Cc: "
                      + ENTRY(i_EmailCCCounter,cEmailCC,cEmailDelimiter)
                      + " ~n".
END.

ASSIGN lSMTPCommand = lSMTPCommand
                    + "Subject: " + cSubject + " ~n".

RUN ip-OutputData(lSMTPCommand,No).
  ASSIGN lSMTPCommand = "Date: " +
                        ENTRY(WEEKDAY(TODAY),cWeekDay) + "," +
                        STRING(DAY(TODAY)) + " " +
                        ENTRY(MONTH(TODAY),cMonth) + " " +
                        STRING(YEAR(TODAY),"9999") + " " +
                        STRING(TIME,"hh:mm:ss") + "~n".

RUN ip-OutputData(lSMTPCommand,No).
/** Set up a boundary value if we have file attachments **/
/** Create multi mime header for email **/
IF cFileAttachment <> "" THEN DO:
  ASSIGN
    cBoundary = "AEZINC_" + STRING(RANDOM(1,99999),"99999") + "_" +
                STRING(RANDOM(1,999999999),"999999999") + "." + "SMZ020970".
  ASSIGN LSMTPCommand = 'MIME-Version: 1.0~n' +
         'Content-type: multipart/mixed; boundary="' + cBoundary + '"~n' +
         'Content-Transfer-Encoding: 7bit~n'.
  RUN ip-OutputData(lSMTPCommand,No).
  ASSIGN LSMTPCommand = 'This is a multi-part MIME Encoded message~n~n' +
  "--" + cBoundary + "~n".
  RUN ip-OutputData(lSMTPCommand,No).
END.
/** Do we have a MIME Type for this messsage **/
IF cMimeHeader <> "" THEN DO:
  RUN ip-ParseParm(cMimeHeader,
                   OUTPUT cMimeType,
                   OUTPUT cCharSet,
                   OUTPUT cFileType).
  ASSIGN LSMTPCommand = IF cFileAttachment <> "" THEN "Mime-Version: 1.0~n" ELSE "".
  ASSIGN LSMTPCommand = LSMTPCommand +
                        "Content-Type: " + cMimeType + "; charset=" + cCharSet + "~n" +
                        "Content-Transfer-Encoding: 7bit~n".
  RUN ip-OutputData(lSMTPCommand,No).
END.
/****************************************************************/
/* Spill out the message.                                       */
/****************************************************************/
  ASSIGN lSMTPCommand = "~n".
  RUN ip-OutputData(lSMTPCommand,No).
  IF LENGTH(cMessageData) < 500 THEN DO:
    ASSIGN lSMTPCommand = cMessageData.
    RUN ip-OutputData(lSMTPCommand,No).
  END.
  ELSE DO:
    DO iCounter = 1 TO LENGTH(cMessageData) BY 499:
      ASSIGN
        cTempValue = IF LENGTH(cMessageData) > iCounter + 499 THEN
            SUBSTRING(cMessageData,iCounter,499)
          ELSE
            SUBSTRING(cMessageData,iCounter, LENGTH(cMessageData) - iCounter + 1).
      ASSIGN lSMTPCommand = cTempValue.
      RUN ip-OutputData(lSMTPCommand,No).
    END.
  END.
  ASSIGN lSMTPCommand = "~n".
  RUN ip-OutputData(lSMTPCommand,No).

/****************************************************************/
/* Process any files attachments.                               */
/****************************************************************/
DO iCounter = 1 TO NUM-ENTRIES(cFileName):
  ASSIGN
    cFile = ENTRY(1,ENTRY(iCounter,cFileAttachment),":")
    cLocalFile = ENTRY(iCounter,cFileName).
  IF SEARCH(cLocalFile) = ? THEN DO: 
    NEXT.
  END.
  RUN ip-ParseParm(ENTRY(iCounter,cFileAttachment),
                   OUTPUT cMimeType,
                   OUTPUT cCharSet,
                   OUTPUT cFileType).
  IF cFileType = "Binary" THEN DO:
    ASSIGN
      cBinaryFile = cLocalFile
      cLocalFile  = cEncodeDir + cFile + "." + STRING(RANDOM(1,99999),"99999").
    RUN base64encode.p(cBinaryFile,
                       cLocalFile).
  END.
/** set up the mime header **/
  ASSIGN LSMTPCommand = "~n--" + cBoundary + "~n" +
                        'Content-type: ' + cMimeType + '; '.
  IF cFileType <> "Binary" THEN
    ASSIGN LSMTPCommand = LSMTPCommand + cCharSet.
  ASSIGN LSMTPCommand =  LSMTPCommand + '~n        name="' + cFile + '"~n'.
  RUN ip-OutputData(lSMTPCommand,No).
  IF cFileType = "Binary" THEN DO:
    ASSIGN LSMTPCommand = 'Content-Transfer-Encoding: base64~n'.
    RUN ip-OutputData(lSMTPCommand,No).
  END.
  ASSIGN LSMTPCommand = 'Content-Disposition: attachment;~n' +
    '        filename="' + cFile + '"~n~n'.
  RUN ip-OutputData(lSMTPCommand,No).
  /** no do the file **/
  INPUT FROM VALUE(cLocalFile) NO-ECHO.
  ASSIGN
    lSMTPCommand = ""
    iLineCount = 1.
    REPEAT:
      IMPORT UNFORMATTED cImportData.
      LSMTPCommand = LSMTPCommand + cImportData + "~n".
      IF iLineCount modulo 5 = 0 THEN DO:
        RUN ip-OutputData(lSMTPCommand,Yes).
        ASSIGN
          LSMTPCommand = "".
      END.
      ASSIGN
        iLineCount = iLineCount + 1.
    END.
    /** Send the last line if not a multiple of 10 **/
    IF lSMTPCommand <> "" THEN DO:
      RUN ip-OutputData(lSMTPCommand,Yes).
    END.
  INPUT CLOSE.
  IF cFileType = "Binary" THEN DO:
  /** if we have a "Binary" file then try to delete the encoded version **/
    OS-DELETE VALUE(cLocalFile) NO-ERROR.
  END.
END. /** process each file attachment **/
IF cFileAttachment <> "" THEN DO:
  ASSIGN
    lSMTPCommand = '~n--' + cBoundary + '--~n~n'.
    RUN ip-OutputData(lSMTPCommand,No).
END.

/****************************************************************/
/* Finish off SMTP                                              */
/****************************************************************/

ASSIGN lSMTPCommand = ".~n" + "QUIT~n".
RUN ip-OutputData(lSMTPCommand,No).

OUTPUT STREAM sLogFile CLOSE.

/****************************************************************/
/* ----------------- End of main routine ---------------------- */
/****************************************************************/

/****************************************************************/
/* This routine reads data off the socket from the server.      */
/****************************************************************/

PROCEDURE ip-OutputData:
  DEFINE INPUT PARAMETER cSMTPCommand AS CHAR NO-UNDO.
  DEFINE INPUT PARAMETER lAttachment  AS LOG NO-UNDO.
  DEF VAR cServerResponse   AS CHAR FORMAT "x(40)" NO-UNDO.
  IF NOT lAttachment
  OR iLogLevel = 1 THEN
    {&LOGGER} cSMTPCommand "~n".
  RUN lmemput (mData, cSMTPCommand).
  lRC = hSocket:WRITE(mData,1,LENGTH(cSMTPCommand)) NO-ERROR.
  RUN ProcessServerResponse (OUTPUT cServerResponse).
  IF NOT lAttachment
  OR iLogLevel = 1 THEN
    {&LOGGER} cServerResponse "~n".
END.
PROCEDURE ProcessServerResponse:

  DEF OUTPUT PARAMETER lResponse AS CHARACTER NO-UNDO.

  DEF VAR i AS INTEGER INIT 1 NO-UNDO.

  /****************************************************************/
  /* Sometimes we may need to wait a little bit for the server to */
  /* respond so we loop a bit till we get something interesting.  */
  /* If we dont, we just bail out of here.                        */
  /****************************************************************/
/*
  DO WHILE i < 6:
    {&LOGGER} "~nBytes on socket: " hSocket:GET-BYTES-AVAILABLE() "~n".
    IF hSocket:GET-BYTES-AVAILABLE() <> 0 THEN LEAVE.
    PAUSE 3 NO-MESSAGE.
    ASSIGN i = i + 1.
  END.
*/
  DO WHILE hSocket:GET-BYTES-AVAILABLE() <> 0:
    IF 100 MOD i = 0 THEN
    {&LOGGER} "~nBytes on socket: " hSocket:GET-BYTES-AVAILABLE() "~n".
    /* PAUSE 3 NO-MESSAGE.*/
    ASSIGN i = i + 1.
    IF i = 10000 THEN LEAVE.
  END.

  IF hSocket:GET-BYTES-AVAILABLE() = 0 THEN RETURN.

  /****************************************************************/
  /* We discover we have something to read from the socket, lets  */
  /* see what we got!  Pop it into raw memory, then put it into   */
  /* a 4GL varible.                                               */
  /****************************************************************/

  RUN lmemset (mData, " ").
  hSocket:READ (mData, 1, GET-SIZE(mData), READ-AVAILABLE).

  RUN lmemget (mData, OUTPUT LResponse).

END. /* PROCEDURE ProcessServerResponse */

/*******************************************************************/
/** Parse mime type and char set out of header                    **/
/** If nothing there, return the default                          **/
/*******************************************************************/
PROCEDURE ip-ParseParm:
DEFINE INPUT PARAMETER cString AS CHAR NO-UNDO.
DEFINE OUTPUT PARAMETER cMimeType AS CHAR NO-UNDO.
DEFINE OUTPUT PARAMETER cCharSet  AS CHAR NO-UNDO.
DEFINE OUTPUT PARAMETER cFileType AS CHAR NO-UNDO.
DEFINE VAR c AS CHAR NO-UNDO.
DEFINE VAR i AS INT  NO-UNDO.
  ASSIGN
    cMimeType = "text/plain"
    cCharSet  = "US-ASCII"
    cFileType = "ASCII".
  DO i = 1 TO NUM-ENTRIES(cString,":"):
    c = ENTRY(i,cString,":").
    CASE ENTRY(1,c,"="):
      WHEN "Type" THEN DO:
        cMimeType = ENTRY(2,c,"=").
      END.
      WHEN "CharSet" THEN DO:
        cCharSet = ENTRY(2,c,"=").
      END.
      WHEN "FileType" THEN DO:
        cFileType = ENTRY(2,c,"=").
      END.
    END CASE.
  END.
END PROCEDURE. /** ip-ParseParm **/
